_ = require 'lodash'

capitalize = (string) ->
  host = string.charAt(0).toUpperCase() + string.slice(1).toLowerCase()
  host?.replace?(/\W/g, '')

generateToken = (domainGroups = []) ->
  tmp = domainGroups.map (f) ->  capitalize(f)
  return tmp[0] if tmp.length is 1
  tmp = tmp.join('')
  tmp?.replace(/[^a-zA-Z0-9 ]/g, '')

tokenizeDomain = (domain = '') ->
  return {} unless domain
  tokenized = domain.toString().toLowerCase().trim()
  splitPort = tokenized.split(':')
  return {} unless splitPort.length
  splitDomain = splitPort[0].split(/\./gi).reverse()
  domain = _.clone(splitDomain).splice(0,(splitDomain.length-1)).reverse().join('.')
  domain = splitDomain[0] unless domain
  _splitDomain = _.clone(splitDomain).reverse()

  results = {}

  if splitDomain.length > 2
    results.sld = _splitDomain[1]
    results.prefix = _splitDomain[0]
  else
    results.prefix = null
    results.sld = _splitDomain[0]

  results.suffix = splitDomain[0]

  if splitPort.length >= 2
    results.port = _.last splitPort
  else
    results.port = null

  results.idn = _splitDomain.join '.'
  results.groups = _splitDomain
  results.token = generateToken _splitDomain
  results

parseDomainString = (hostname, referer) ->
  parsed = /^((http|https|ftp|ftps|news|ssh|sftp|gopher):[\/]{2,})?([^\/]+)/.exec(hostname)
  refererParsed = /^((http|https|ftp|ftps|news|ssh|sftp|gopher):[\/]{2,})?([^\/]+)/.exec(referer)

  data =
    url: parsed[0]
    protocolFormat: parsed[1]
    protocol: parsed[2]
    name: parsed[3]
    uri: parsed['input']

  data.host = tokenizeDomain data.name
  data.referer = tokenizeDomain refererParsed[3] if refererParsed
  data.token = data.host.token
  data.level = (number) -> data.idn.split(/\./gi).reverse()[parseInt(number)-1]
  data.toString = -> data.name
  data

module.exports = (request) ->
  parseDomainString request.hostname.toLowerCase().trim(), request.get 'Referer'

