express = require 'express'
fs = require 'fs'

describe 'Unit test', ->
  timestamp = (new Date).getTime()
  app = null
  host = null
  port = null
  hostAddress = null
  app = express()
  require('express4x-bootstrap-form-data').use app, {}
  require('../../src/index').use app, {}

  app.all '/', (req, res) ->
    res.type 'json'
    res.json res.getDomainToken()

  before ->
    @server = app.listen 3000, =>
      host = @server.address().address
      port = @server.address().port
      #console.log 'Example app listening at http://%s:%s', host, port
      @express = this

  after ->
    @server.close()

  describe 'request', ->
    it 'should return 200 & json', (done) ->
      @timeout 1000
      supertest(app)
        .get('/')
        .set('Accept', 'application/json')
        .expect('Content-Type', /json/)
        .expect(200, done);

    it 'should return token', (done) ->
      @timeout 1000
      supertest(app)
        .get('/')
        .set('Accept', 'application/json')
        .expect('Content-Type', /json/)
        .expect 200, (error, res) ->
          expect(res.body.url).to.equal '127.0.0.1'
          expect(res.body.name).to.equal '127.0.0.1'
          expect(res.body.uri).to.equal '127.0.0.1'
          expect(res.body.token).to.equal '127001'
          expect(res.body.host).to.exist
          done()





